SystemOrganization addCategory: #'Mars-Examples'!

Object subclass: #MarsBrowser
	instanceVariableNames: 'announcer selectedCategory selectedBehavior selectedMethod announcers selectedMethodSource mode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mars-Examples'!

!MarsBrowser methodsFor: 'announcements' stamp: 'NicolasPasserini 2/2/2012 21:05'!
addAnnouncer: anAnnouncer
	announcers add: anAnnouncer! !

!MarsBrowser methodsFor: 'announcements' stamp: 'NicolasPasserini 2/2/2012 21:05'!
announce: anAnnouncement
	announcers do: [ :ann | ann announce: anAnnouncement ]! !

!MarsBrowser methodsFor: 'accessing' stamp: 'NicolasPasserini 2/2/2012 21:05'!
behaviors
	^selectedCategory ifNil: [ #() ] ifNotNil: [ SystemOrganization classesInCategory: selectedCategory ]
	! !

!MarsBrowser methodsFor: 'accessing' stamp: 'GuillermoPolito 2/29/2012 17:47'!
categories
	^SystemOrganization categories! !

!MarsBrowser methodsFor: 'behavior' stamp: 'NicolasPasserini 2/2/2012 21:05'!
classMode
	self mode: GtkBrowserClassMode new.! !

!MarsBrowser methodsFor: 'view-creation' stamp: 'GuillermoPolito 2/29/2012 18:00'!
createBehaviorsPanel
	 ^ MSplitter new 
		beVertical;
		addChild: (MList new 
			model: self; 
			bindContentsOn: #behaviors; 
			bindSelectedItemOn: #selectedBehavior);
		addChild: (MPanel new
			layoutPolicy: MLayout horizontal;
			addChild: (MButton new height: 30; label: 'Instance'; onClick: [ self instanceMode ]);
			addChild: (MButton new height: 30; label: '?');
			addChild: (MButton new height: 30; label: 'Class'; onClick: [ self classMode ])).
! !

!MarsBrowser methodsFor: 'view-creation' stamp: 'GuillermoPolito 2/29/2012 18:00'!
createListsPanel
	^ MSplitter new 
		beHorizontal;
		addChild: (MList new 
			model: self;
			bindContentsOn: #categories; 
			bindSelectedItemOn: #selectedCategory);
		addChild: self createBehaviorsPanel;
		addChild: (MList new 
			model: self;
			bindContentsOn: #methods; 
			bindSelectedItemOn: #selectedMethod).! !

!MarsBrowser methodsFor: 'initialize-release' stamp: 'NicolasPasserini 2/2/2012 21:05'!
initialize
	super initialize.
	announcers := Set new.! !

!MarsBrowser methodsFor: 'behavior' stamp: 'NicolasPasserini 2/2/2012 21:05'!
instanceMode
	self mode: GtkBrowserInstanceMode new.! !

!MarsBrowser methodsFor: 'accessing' stamp: 'NicolasPasserini 2/2/2012 21:05'!
methods
	^selectedBehavior ifNil: [ #() ] ifNotNil: [ self mode methodsFor: selectedBehavior ]! !

!MarsBrowser methodsFor: 'accessing' stamp: 'NicolasPasserini 2/2/2012 21:05'!
mode
	^ mode ifNil: [ mode := GtkBrowserInstanceMode new ]
! !

!MarsBrowser methodsFor: 'accessing' stamp: 'NicolasPasserini 2/2/2012 21:05'!
mode: anObject
	mode := anObject.
	self announce: (MarsPropertyHasChanged property: #selectedBehavior).
	self announce: (MarsPropertyHasChanged property: #methods).
! !

!MarsBrowser methodsFor: 'view-creation' stamp: 'GuillermoPolito 2/29/2012 17:21'!
open
	| window |
	window := MWindow new
		title: 'Browser';
	 	extent: 600@400;
		layoutPolicy: MLayout vertical;
		addChild: self createListsPanel;
		addChild: (GtkTextView new 
			model: self; 
			bindContentsOn: #selectedMethodSource;
			height: 200).	
	
	self announce: (MarsPropertyHasChanged property: #categories).

	window show.
	^window! !

!MarsBrowser methodsFor: 'accessing' stamp: 'NicolasPasserini 2/2/2012 21:05'!
selectedBehavior
	^selectedBehavior
	! !

!MarsBrowser methodsFor: 'accessing' stamp: 'NicolasPasserini 2/2/2012 21:05'!
selectedBehavior: aBehavior
	selectedBehavior := aBehavior.
	self announce: (MarsPropertyHasChanged property: #selectedBehavior).
	self announce: (MarsPropertyHasChanged property: #methods).
	self selectedMethod: nil.! !

!MarsBrowser methodsFor: 'accessing' stamp: 'NicolasPasserini 2/2/2012 21:05'!
selectedCategory
	selectedCategory! !

!MarsBrowser methodsFor: 'accessing' stamp: 'NicolasPasserini 2/2/2012 21:05'!
selectedCategory: aCategory
	selectedCategory := aCategory.
	self announce: (MarsPropertyHasChanged property: #selectedCategory).
	self announce: (MarsPropertyHasChanged property: #behaviors).
	
	self selectedBehavior: nil.
! !

!MarsBrowser methodsFor: 'accessing' stamp: 'NicolasPasserini 2/2/2012 21:05'!
selectedMethod
	^selectedMethod! !

!MarsBrowser methodsFor: 'accessing' stamp: 'NicolasPasserini 2/5/2012 13:10'!
selectedMethod: aSelector
	selectedMethod := aSelector.
	selectedMethod ifNotNil: 
		[self selectedMethodSource: (self mode lookupSelector: selectedMethod inBehavior: selectedBehavior) sourceCode asString].
	self announce: (MarsPropertyHasChanged property: #selectedMethod).! !

!MarsBrowser methodsFor: 'accessing' stamp: 'NicolasPasserini 2/2/2012 21:05'!
selectedMethodSource
	^selectedMethodSource! !

!MarsBrowser methodsFor: 'accessing' stamp: 'NicolasPasserini 2/2/2012 21:05'!
selectedMethodSource: someText
	selectedMethodSource := someText.
	self announce: (MarsPropertyHasChanged property: #selectedMethodSource)! !
